/* V 5.12.23 */
#include <TimerOne.h>
#include <SPI.h>                                        // Подключаем библиотеку  для работы с шиной SPI
#include <UTFT.h>                                       // Библиотека для работы с дисплеем
#include <URTouch.h>                                    // Библиотека для работы с тачскрином дисплея

UTFT Display(TFT01_24SP, 9, 8, 12, 11, 10);             // SCK, SDI (MOSI), D/C, RESET, CS

#define T_CLK   2
#define T_CS    3
#define T_MOSI  A3
#define T_MISO  A2
#define T_IRQ   A1

/*-----------------------------------------------------------------------------------------------------*/
/*                          ТЫ НЕ ЗАБЫЛ ОТКАЛИБРОВАТЬ ТАЧСКРИН  URTouchCD.h                            */
/*-----------------------------------------------------------------------------------------------------*/
URTouch myTouch(T_CLK, T_CS, T_MOSI, T_MISO, T_IRQ);  // Создаём объект библиотеки URTouch

int X_T, Y_T;
byte Setup          = 1;
byte Start0         = 0;
byte But_Set        = 0;

extern uint8_t BigFont[];
extern uint8_t Seven_Seg_Num[];                        // 64x100
extern uint8_t Seven_Seg_Simb[];                       // 32x100

int X_Set = 15, Y_Set = 185;                           // Кнопка SET
int X_Start = 175, Y_Start = 185;                      // Кнопка START

int X_D_1 = 30,  Y_D_1 = 80;                           // Кнопка цифры десятки часов
int X_D_2 = 95,  Y_D_2 = 80;                           // Кнопка цифры еденицы часов
int X_D_3 = 195, Y_D_3 = 80;                           // Кнопка цифры десятки минут
int X_D_4 = 260, Y_D_4 = 80;                           // Кнопка цифры еденицы минут

byte Hour[]         = {0, 1};
byte Min[]          = {0, 1};
byte Sec[]          = {0, 0};

int Temp;
#define Beep          4
#define Power_OFF     7
/*-----------------------------------------------------------------------------------------------------*/
const float R1      = 2000;                             // резисторы делителя напряжения на
const float R2      = 100000;                           // входное напряжение

const float Typ_Vbg = 1.055; // 1.0 -- 1.2              // эту константу необходимо откалибровать индивидуально

float Akku[]        = {0};
/*-----------------------------------------------------------------------------------------------------*/
#define Hour_1_P      Hour[0] += 1; if(Hour[0] >= 24) Hour[0] = 0;
#define Min_10_P      Min[0] += 10; if(Min[0]  >= 60) Min[0] = 0;
#define Min_1_P       Min[0]  += 1; if(Min[0]  >= 60) Min[0] = 0;
#define Clear_Sec     Sec[0] = 0; Sec[1] = 0;
#define BEEP          digitalWrite(Beep, HIGH); delay(200); digitalWrite(Beep, LOW);
#define Print_V       Read_Volt(); Display.setFont(BigFont); Display.printNumF(Akku[0], 2, 185, 15); Display.print("V", 250, 15);
/*=======================================================================================================
                                            Инициализация
=======================================================================================================*/
void setup()
{
  pinMode(Beep, OUTPUT);
  pinMode(Power_OFF, OUTPUT);
  digitalWrite(Power_OFF, HIGH);
  
  Timer1.initialize(1000000);                           // timing for 1000 ms
  Timer1.attachInterrupt(TimingISR);                    // declare the interrupt serve routine : TimingISR

  Display.InitLCD(1);
  Display.fillScr(VGA_NAVY);                            // Очистка экрана с заливкой заданным цветом

  analogReference(DEFAULT);                             // DEFAULT INTERNAL использовать Vcc как AREF
  Read_Volt();
/*------------------------------------------------------------------------------------------------------*/
  Display.setFont(BigFont);
  Display.setBackColor(VGA_NAVY);                       // Выбор цвета для фона текста
  Display.setColor(VGA_WHITE);
  Display.print("<< TIMER : KUHEN >>", CENTER, 15);
/*-----------------------------------------------------------------------------------------------------*/
  myTouch.InitTouch();
  myTouch.setPrecision(PREC_MEDIUM);
  
  Draw_Frame(5, 50,  315, 170);
  Draw_Buttons(0, X_Set, Y_Set);                        // Кнопка Setup
  Draw_Buttons(1, X_Start, Y_Start);                    // Кнопка Start
  Display.setBackColor(VGA_NAVY);                       // Выбор цвета для фона текста
  Draw_Text();
  Display.setFont(Seven_Seg_Simb);  
  Display.print("0", CENTER, 60);
  Sec[1] = 0;
}
/*=======================================================================================================
                                              Главный цикл
=======================================================================================================*/
void loop()
{
  Print_V                                               // Выводим на дисплей напряжение аккумулятора
  Buttons();
  if (Start0 == 1)  Draw_Text();
  if (Start0 == 2) {Draw_Text(); Start0 = 3;}
  if (Start0 == 3) 
  {
    for (byte i = 0; i <= 4; i++) 
    {
      BEEP  delay(700); Start0 = 0; 
      if (i == 4) digitalWrite(Power_OFF, LOW);
    }
  }
  if (Sec[1] == 30) {BEEP  digitalWrite(Power_OFF, LOW);}
  if (Akku[0] <= 3.00) {BEEP  delay(3000);}
  if (Akku[0] <= 2.50) {digitalWrite(Power_OFF, LOW);}
}
/*=====================================================================================================*/
